import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;
import java.util.ArrayList;
import java.awt.Color;
/**
 * Write a description of class BombermanWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BombermanWorld extends World
{  
    int p1Lives = 3;
    int p2Lives = 3;
    int counter1, counter2;
    int Player1Speed;
    int Player2Speed;
    int Player1Bombs;
    int Player2Bombs;
    int Player1Power;
    int Player2Power;
    private Player_1 player1;
    private Player_2 player2;
    private Lives_Data lifedata1;
    private Lives_Data lifedata2;
    private Power_Data powerdata1;
    private Power_Data powerdata2;
    private Speed_Data speeddata1;
    private Speed_Data speeddata2;
    private MaxBombs_Data bombdata1;
    private MaxBombs_Data bombdata2;
    /**
     * Constructor for objects of class BombermanWorld.
     */
    public BombermanWorld()
    {    
        super(816, 900, 1); 
        setBackground("Background.png");
        setPaintOrder(Game_Over2.class, Game_Over1.class, Speed_Data.class, Lives_Data.class, Power_Data.class, MaxBombs_Data.class, Explosion.class, Bomberman.class, Bomb_1.class, Bomb_2.class, Wall.class, Block.class);
        //sets up the worlds blocks
        addWalls();
        addBlocks();
        canMove();
    }
    public void act()
    {
        //reduces timers for death counter
        if(counter1>0){
            counter1--;
        }
        if(counter2>0){
            counter2--;
        }
        //refreshes the data for the players
        refreshstats();
        //stops the game and shows game over scren when plaer runs out of lives
        if(p1Lives<=0){
            addObject(new Game_Over2(),408,292);
            Greenfoot.stop();
        }
        if(p2Lives<=0){
            addObject(new Game_Over1(),408,292);
            Greenfoot.stop();
        }
    }
    /**
     * Adds walls, plaers, and data to game
     */
    public void addWalls()
    {
        for(int i=0; i<17; i++){
            addObject(new Wall(), 24, ((48*i)+24));
            addObject(new Wall(), ((48*i)+24), 24);
            addObject(new Wall(), 792, ((48*i)+24));
            addObject(new Wall(), ((48*i)+24), 792);
       }
       for(int i=0; i<7; i++){
           addObject(new Wall(), (120+(96*i)), 120);
           addObject(new Wall(), (120+(96*i)), 216);
           addObject(new Wall(), (120+(96*i)), 312);
           addObject(new Wall(), (120+(96*i)), 408);
           addObject(new Wall(), (120+(96*i)), 504);
           addObject(new Wall(), (120+(96*i)), 600);
           addObject(new Wall(), (120+(96*i)), 696);
       }
       //adds plaers
       player1 = new Player_1();
       addObject(player1, 70, 72);
       player2 = new Player_2();
       addObject(player2, 745, 745);
       //adds the life data
       lifedata1 = new Lives_Data(1,p1Lives);
       addObject(lifedata1, 100, 850);
       lifedata2 = new Lives_Data(2,p2Lives);
       addObject(lifedata2, 508, 850);
       powerdata1 = new Power_Data(1,Player1Power);
       addObject(powerdata1,100,880);
       powerdata2 = new Power_Data(2,Player2Power);
       addObject(powerdata2,508,880);
       speeddata1 = new Speed_Data(1,Player1Speed);
       addObject(speeddata1,220,850);
       speeddata2 = new Speed_Data(2,Player2Speed);
       addObject(speeddata2,628,850);
       bombdata1 = new MaxBombs_Data(1,Player1Bombs);
       addObject(bombdata1,220,880);
       bombdata2 = new MaxBombs_Data(2,Player2Bombs);
       addObject(bombdata2,628,880);
       //adds title for player data
       GreenfootImage player1 = getBackground();
       player1.setColor(Color.WHITE);
       player1.drawString("Player 1", 30,830);
       GreenfootImage player2 = getBackground();
       player2.setColor(Color.WHITE);
       player2.drawString("Player 2", 438,830);
    }
    /**
     * Adds blocks to world
     */
    public void addBlocks()
    {
        for(int i = 0; i<500; i++){
            //adds block randomly to world
            int block = Greenfoot.getRandomNumber(2);
            int x = Greenfoot.getRandomNumber(15);
            int y = Greenfoot.getRandomNumber(15);
            if(block == 1){
                ArrayList<Object> objs = (ArrayList<Object>) getObjectsAt((72+(x*48)), (72+(y*48)), Block.class);
                if(objs.size() <= 0){
                    addObject(new Block(), (72+(x*48)), (72+(y*48)));
                }
            }   
        }
    }
    /**
     * Removes blocks around player spawn
     */
    public void canMove()
    {
        removeObjects(getObjectsAt(72, 72, Block.class));
        removeObjects(getObjectsAt(120, 72, Block.class));
        removeObjects(getObjectsAt(72, 120, Block.class));
        removeObjects(getObjectsAt(744, 744, Block.class));
        removeObjects(getObjectsAt(696, 744, Block.class));
        removeObjects(getObjectsAt(744, 696, Block.class));
    }
    /**
     * Reduces players life if counter is at 0
     */
    public void reduceLife(int player)
    {
        if(player == 1 && counter1 == 0){
            p1Lives--;
            counter1 = 30;
            player1.hit();
        }
        if(player == 2 && counter2 == 0){
            p2Lives--;
            counter2 = 30;
            player2.hit();
        } 
    }
    /**
     * Used to store data from the player
     */
    public void storePlayerData(int player, int speed, int bombs, int power)
    {
        if(player==1){
            Player1Speed = speed;
            Player1Bombs = bombs;
            Player1Power = power;
        }
        if(player==2){
            Player2Speed = speed;
            Player2Bombs = bombs;
            Player2Power = power;
        }
    }
    /**
     * Refreshes the player data
     */
    public void refreshstats()
    {
        //removes old data
        removeObject(lifedata1);
        removeObject(lifedata2);
        //adds new data
        lifedata1 = new Lives_Data(1,p1Lives);
        addObject(lifedata1, 100, 850);
        lifedata2 = new Lives_Data(2,p2Lives);
        addObject(lifedata2, 508, 850);
        removeObject(powerdata1);
        removeObject(powerdata2);
        powerdata1 = new Power_Data(1,Player1Power);
        addObject(powerdata1,100,880);
        powerdata2 = new Power_Data(2,Player2Power);
        addObject(powerdata2,508,880);
        removeObject(speeddata1);
        removeObject(speeddata2);
        speeddata1 = new Speed_Data(1,Player1Speed);
        addObject(speeddata1,220,850);
        speeddata2 = new Speed_Data(2,Player2Speed);
        addObject(speeddata2,628,850);
        removeObject(bombdata1);
        removeObject(bombdata2);
        bombdata1 = new MaxBombs_Data(1,Player1Bombs);
        addObject(bombdata1,220,880);
        bombdata2 = new MaxBombs_Data(2,Player2Bombs);
        addObject(bombdata2,628,880);
    }
    /**
     * Adds player life
     */
    public void addLife(int player)
    {
        if(player == 1){
            if(p1Lives<3){
                p1Lives++;
            }
        }
        if(player == 2){
            if(p2Lives<3){
                p2Lives++;
            }
        }
    }
}
